#ifndef _android_sound_H_
#define _android_sound_H_

#include <jni.h>
#include <android_native_app_glue.h>
#include <android/log.h>
#include <string>

extern JNIEnv* gAndroidActivityEnv;
extern jobject  gActivityInstance;
extern jmethodID gPlaySound;

extern jmethodID gStopMusic;
extern jmethodID gPlayIntroMusic;
extern jmethodID gPlayLevelCompleteMusic;
extern jmethodID gPlayMainTheme;

static void jPlaySound(const char* key)
{
	if (!gPlaySound)
	{
		__android_log_print(ANDROID_LOG_INFO, "Rails", "No Java VM method defined. Cannot invocate !");
		return;
	}
	jstring jkeyStr = gAndroidActivityEnv->NewStringUTF(key);
	gAndroidActivityEnv->CallVoidMethod(gActivityInstance, gPlaySound, jkeyStr);
	gAndroidActivityEnv->DeleteLocalRef(jkeyStr);
	
	return;
}

static void jStopMusic()
{
	if (!gStopMusic)
	{
		__android_log_print(ANDROID_LOG_INFO, "Rails", "No Java VM method defined. Cannot invocate !");
		return;
	}
	gAndroidActivityEnv->CallVoidMethod(gActivityInstance, gStopMusic);
}

static void jPlayIntroMusic()
{
	if (!gPlayIntroMusic)
	{
		__android_log_print(ANDROID_LOG_INFO, "Rails", "No Java VM method defined. Cannot invocate !");
		return;
	}
	gAndroidActivityEnv->CallVoidMethod(gActivityInstance, gPlayIntroMusic);
}

static void jPlayLevelCompleteMusic()
{
	if (!gPlayLevelCompleteMusic)
	{
		__android_log_print(ANDROID_LOG_INFO, "Rails", "No Java VM method defined. Cannot invocate !");
		return;
	}
	gAndroidActivityEnv->CallVoidMethod(gActivityInstance, gPlayLevelCompleteMusic);
}

static void jPlayMainTheme()
{
	if (!gPlayMainTheme)
	{
		__android_log_print(ANDROID_LOG_INFO, "Rails", "No Java VM method defined. Cannot invocate !");
		return;
	}
	gAndroidActivityEnv->CallVoidMethod(gActivityInstance, gPlayMainTheme);
}

#endif