#ifndef _mySTEP_H_NSGeometry
#define _mySTEP_H_NSGeometry

#include <algorithm>

#   define ABS(a) fabs(a)
#   define MAX(a, b) std::max((float(a)), (float(b)))
#   define MIN(a, b) std::min((float(a)), (float(b)))

class NSSize
{
public:
//	NSSize() { width = 0; height = 0; }
//	NSSize(float s) { width = s; height = s; }
//	NSSize(float _w, float _h) { width = _h; height = _w; }
	NSSize(): width(0), height(0) {}
	NSSize(float w, float h): width(w), height(h) {}
    float width;
	float height;
};

class NSPoint
{
public:
//	NSPoint() { x = 0; y = 0; }
//	NSPoint(float p) { x = p; y = p; }
//	NSPoint(float _x, float _y) { x = _x; y = _y; }
	NSPoint(): x(0), y(0) {}
	NSPoint(float _x, float _y): x(_x), y(_y) {}
    float x;
	float y;
};

class NSRect
{
public:
	NSRect()
	{
		origin = NSPoint();
		size = NSSize();
	}
	NSRect(float x, float y, float w, float h)
	{
		origin = NSPoint(x, y);
		size = NSSize(w, h);
	}
	NSRect(const NSPoint& pt, const NSSize& s)
	{
		origin = pt;
		size = s;
	}
    NSPoint origin;
	NSSize size;
};
/*
typedef struct _NSPoint
{
	float x;
	float y;
} NSPoint, *NSPointArray, *NSPointPointer;

typedef struct _NSSize
{
	float width;
	float height;
} NSSize, *NSSizeArray, *NSSizePointer;

typedef struct _NSRect
{
	NSPoint origin;
	NSSize size;
} NSRect, *NSRectArray, *NSRectPointer;
*/

typedef enum _NSRectEdge
{
	NSMinXEdge,
	NSMinYEdge,
	NSMaxXEdge,
	NSMaxYEdge
} NSRectEdge;

#define NSZeroPoint NSPoint()  						// A zero point
#define NSZeroRect NSRect()    						// A zero origin rectangle
#define NSZeroSize NSSize()    						// A zero size rectangle

//extern NSPoint NSZeroPoint;  						// A zero point
//extern NSRect  NSZeroRect;    						// A zero origin rectangle
//extern NSSize  NSZeroSize;    						// A zero size rectangle

//#if 1	// use macros instead of function calls (tradeoff speed for code size)
//
//#define NSMakePoint(x, y)		((NSPoint){(float) (x), (float) (y)})
//#define NSMakeSize(w, h)		((NSSize){(float) (w), (float) (h)})
//#define NSMakeRect(x, y, w, h)	((NSRect){{(float) (x), (float) (y)}, {(float) (w), (float) (h)}})
//
//#else

// Returns an NSPoint having x-coordinate X and y-coordinate Y
extern NSPoint NSMakePoint(float x, float y);
// Returns NSSize having width WIDTH and height HEIGHT
extern NSSize  NSMakeSize(float w, float h);
// Returns NSRect having point of origin (X, Y) and size {W, H}
extern NSRect  NSMakeRect(float x, float y, float w, float h);

//#endif

#define	NSMaxX(aRect)	((aRect).origin.x + (aRect).size.width)  // max x coord
#define	NSMaxY(aRect)	((aRect).origin.y + (aRect).size.height) // max y coord
#define	NSMidX(aRect)	(NSMinX(aRect) + NSWidth(aRect) / 2.0)	 // mid x coord
#define	NSMidY(aRect)	(NSMinY(aRect) + NSHeight(aRect) / 2.0)	 // mid y coord
#define	NSMinX(aRect)	((aRect).origin.x)						 // min x coord
#define	NSMinY(aRect)	((aRect).origin.y)						 // min y coord
#define	NSWidth(aRect)	((aRect).size.width)					 // rect width
#define	NSHeight(aRect)	((aRect).size.height)					 // rect height

// Returns a new size inset by dX and dY
// extern NSSize GSInsetSize(NSSize aSize, float dX, float dY);

// Returns the rectangle obtained by moving each of
// ARECT's horizontal sides inward by DY and each of
// ARECT's vertical sides inward by DX.
extern NSRect NSInsetRect(NSRect aRect, float dX, float dY);

// Returns the rectangle obtained by translating ARECT
// horizontally by DX and vertically by DY
extern NSRect NSOffsetRect(NSRect aRect, float dX, float dY);

// Divides ARECT into two rectangles (namely SLICE and
// REMAINDER) by "cutting" ARECT---parallel to, and a
// distance AMOUNT from the edge v of ARECT determined
// by EDGE.  You may pass 0 in as either of SLICE or
// REMAINDER to avoid obtaining either of the created
// rectangles.
extern void NSDivideRect(NSRect aRect,
						 NSRect *slice,
						 NSRect *remaind,	// name conflict with math.h remainder()
						 float amount,
						 NSRectEdge edge);

// Returns a rect obtained by expanding ARECT minimally
// so that all four of its defining components are ints
extern NSRect NSIntegralRect(NSRect aRect);

// Returns the smallest rectangle which contains both
// ARECT and BRECT (modulo a set of measure zero).  If
// either of ARECT or BRECT is an empty rectangle, then
// the other rectangle is returned.  If both are empty,
// then the empty rectangle is returned.
extern NSRect NSUnionRect(NSRect aRect, NSRect bRect);

// Returns the largest rect which lies in both ARECT
// and BRECT.  If ARECT & BRECT have empty intersection
// (or, rather, intersection of measure zero, since
// this includes having their intersection be only a
// point or a line), then the empty rect is returned.
extern NSRect NSIntersectionRect(NSRect aRect, NSRect bRect);

// Returns 'YES' if ARECT's and BRECT's origin and size
// are the same.
extern bool NSEqualRects(NSRect aRect, NSRect bRect);

// Returns 'YES' if ASIZE's and BSIZE's width and
// height are the same.
extern bool NSEqualSizes(NSSize aSize, NSSize bSize);

// Returns 'YES' iff APOINT's and BPOINT's x- and
// y-coordinates are the same. /
extern bool NSEqualPoints(NSPoint aPoint, NSPoint bPoint);

// Returns 'YES' iff the area of ARECT is zero (if
// either ARECT's width or height is negative or zero).
extern bool NSIsEmptyRect(NSRect aRect);

// Returns 'YES' iff APOINT is inside ARECT.
extern bool NSMouseInRect(NSPoint aPoint, NSRect aRect, bool flipped);
extern bool NSPointInRect(NSPoint aPoint, NSRect aRect);

// Returns 'YES' if ARECT totally encloses BRECT.  For
// this to be the case, ARECT cannot be empty, nor can
// any side of BRECT coincide with any side of ARECT.
extern bool NSContainsRect(NSRect aRect, NSRect bRect);

// Returns Yes if aRect intersects bRect.
extern bool NSIntersectsRect(NSRect aRect, NSRect bRect);

#endif /* _mySTEP_H_NSGeometry */