//
//  RailsPrefsController.h
//  ShortLine
//
//  Created by Ievgen Ovcharenko
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#ifndef _RailsPrefsController_h
#define _RailsPrefsController_h

#include "NSDictionary.h"

class RailsPrefsController;
typedef std::tr1::shared_ptr< RailsPrefsController > RailsPrefsControllerPtr;

class RailsPrefsController
{
	//NSDictionaryPtr _userDefaults;

public:
	static RailsPrefsController* sharedController();
	
	static void reinitAllLevelsInfo();

	int moneyRecordForLevelIndex(int levelIndex);
	bool setMoneyRecordForLevelIndex(int money, int levelIndex);
	bool isRecordMoneyForLevelIndex(int money, int levelIndex);

	static int prefsHash(NSDictionaryPtr prefsDict);
	int prefsHash();
	bool isValidPrefsHash();
	void updatePrefsHash();

	static int achievementsHash(NSDictionaryPtr achievements);
	int achievementsHash();
	bool isValidAchievementsHash();
	void updateAchievementsHash();

	static int levelsInfoHash(std::vector<int> levelsInfoArray);
	int levelsInfoHash();
	bool isValidLevelsInfoHash();
	void updateLevelsInfoHash();
	
	int getSnapshotHash(NSDictionaryPtr snapshotDict);
	bool isValidSnapshotHash(NSDictionaryPtr snapshotDict);
	void updateSnapshotHash(NSDictionaryPtr snapshotDict);
	
	int chaptersUnlockedHash();
	bool isChaptersUnlocked();
	void setChaptersUnlocked(bool isUnlocked);
	void updateChaptersUnlockedHash();
	
	void resetGameProgressPreferences();
	
private:
	static void emptyLevelsInfo();

	std::vector<int>& allLevelsInfo();
	void saveAllLevelsInfo();
};

#endif